SystemOrganization addCategory: #'Pier-SW2-Sw1Features'!

PRExternalLink subclass: #PRCustomLink
	instanceVariableNames: ''
	classVariableNames: 'StringToUrlBlocks'
	poolDictionaries: ''
	category: 'Pier-SW2-Sw1Features'!

!PRCustomLink commentStamp: 'JCB 2/13/2009 14:32' prior: 0!
A PRCustomLink is an external link which can be modified by sudo-admins.  Examples of things that can be added are:
	PRCustomLink addConversion: [:aString | (('cc######' match: aString) and: [(aString copyFrom: 3 to: 8) isAllDigits])
			ifTrue: [(aString copyFrom: 3 to: 8) asInteger < 94477
				ifTrue: ['http://cmidom1srv/cmi/formsarchive.nsf/ReqNumber/' , (aString asLowercase)]
				ifFalse: ['http://cmidom1srv/cmi/forms.nsf/ReqNumber/' , (aString asLowercase)]]].
	PRCustomLink addConversion: [:aString | (('cc######dr' match: aString) and: [(aString copyFrom: 3 to: 8) isAllDigits])	
			ifTrue: ['http://cmidom1srv/cmi/forms.nsf/ReqNumber/' , (aString asLowercase)]].
	PRCustomLink addConversion: [:aString | (('xc######' match: aString) and: [(aString copyFrom: 3 to: 8) isAllDigits])
			ifTrue: ['http://cmidom1srv/cmi/cingular.nsf/ReqNumber/' , (aString asLowercase)]].
	PRCustomLink addConversion: [:aString | (('Case #*-#*' match: aString)
			and: [| numbers | numbers := (aString copyFrom: 6 to: aString size) findTokens: '-'.  numbers size = 2 and: [(numbers contains: [:aSubString | aSubString isAllDigits not]) not]])	
				ifTrue: ['http://cmiweb1/champs/Subcase_Details.asp?idn=' , (aString copyFrom: 6 to: aString size)]].
	PRCustomLink addConversion: [:aString | (('Case ######*' match: aString) and: [(aString copyFrom: 6 to: 11) isAllDigits])
			ifTrue: ['http://cmiweb1/champs/Case_Details.asp?idn=' , (aString copyFrom: 6 to: 11)]].
	PRCustomLink addConversion: [:aString | ('\\cmifs01\*' match: aString) 
			ifTrue: ['file:///' , (aString copy translateWith: ((String withAll: Character allCharacters) at: $\ asciiValue + 1 put: $/; yourself))]].
	PRCustomLink addConversion: [:aString | (('doc *' match: aString) and: [(aString copyFrom: 5 to: aString size) isAllDigits and: [aString size > 5]])
			ifTrue: [aString size > 9
				ifTrue: ['http://docloader/Docloader/docloader.aspx?action=view&foldernum=', (aString copyFrom: 5 to: 							aString size)]
				ifFalse: ['http://Docloader/Docloader/docloader.aspx?action=view&docnum=', (aString copyFrom: 5 to: aString size)]]]
		
		
		Instance Variables
		!

!PRCustomLink class methodsFor: 'accessing' stamp: 'JCB 2/13/2009 14:26'!
addConversion: aBlock
	aBlock argumentCount = 1
			ifFalse: [self error: 'This expects a one argument block'].
	self stringToUrlBlocks add: aBlock! !

!PRCustomLink class methodsFor: 'private-testing' stamp: 'JCB 2/24/2009 13:46'!
conversions: aCollection
	aCollection isCollection ifFalse: [self error: 'The argument must be a collection.'].
	StringToUrlBlocks := aCollection! !

!PRCustomLink class methodsFor: 'testing' stamp: 'JCB 2/13/2009 14:27'!
isValidReference: aString
	^ self stringToUrlBlocks
		contains: [:block | (block value: aString) notNil]! !

!PRCustomLink class methodsFor: 'accessing' stamp: 'JCB 2/13/2009 14:27'!
stringToUrlBlocks
	StringToUrlBlocks isNil
		ifTrue: [StringToUrlBlocks := OrderedCollection new].
	^ StringToUrlBlocks! !

!PRCustomLink methodsFor: 'accessing-dynamic' stamp: 'JCB 2/13/2009 14:33'!
url
	^ (self class stringToUrlBlocks
		detect: [:e | (e value: self reference) notNil])
		value: self reference! !

!PRViewRenderer methodsFor: '*pier-SW2-Sw1Features' stamp: 'JCB 2/24/2009 09:33'!
visitPierTable: anObject
	| table | 
	(table := html table) attributes addClass: 'prtable'.
	table with: [super visitTable: anObject]! !

!PRTable methodsFor: '*pier-SW2-Sw1Features' stamp: 'JCB 2/24/2009 09:33'!
accept: aVisitor
	aVisitor visitPierTable: self! !

!PRSearchWidget methodsFor: '*pier-SW2-Sw1Features' stamp: 'JCB 2/13/2009 17:15'!
findItems
	"Changed code to replace 'structure' in the below, it was originally root."
	
	^ (self context structure fullTextSearch subString: self searchText) contents! !

!PRVisitor methodsFor: '*pier-SW2-Sw1Features' stamp: 'JCB 2/24/2009 09:26'!
visitPierTable: anObject
	self visitTable: anObject! !

PRLinkTest subclass: #PRCustomLinkTest
	instanceVariableNames: 'originalConversions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-SW2-Sw1Features'!

!PRCustomLinkTest commentStamp: 'JCB 2/26/2009 21:55' prior: 0!
A PRCustomLinkTest is is a test for the custom link class.  This uses some private methods of the PRCustomLink to backup the current conversion blocks, and restore them after the test is complete.

Instance Variables
	originalConversions:		<OrderedCollection of Blocks>

originalConversions
	- Backup of the original conversion blocks
!

!PRCustomLinkTest methodsFor: 'private' stamp: 'JCB 2/24/2009 13:33'!
actualClass
	^ PRCustomLink! !

!PRCustomLinkTest methodsFor: 'private' stamp: 'JCB 2/24/2009 13:33'!
referenceString
	^ 'case 12345'! !

!PRCustomLinkTest methodsFor: 'running' stamp: 'JCB 2/24/2009 14:02'!
setUp
	super setUp.
	originalConversions := self actualClass stringToUrlBlocks.
	self actualClass conversions: OrderedCollection new.
	self actualClass
		addConversion: [:aString | | numbers | (('case #*' match: aString)
					and: [numbers := aString copyFrom: 6 to: aString size.
						(numbers
							contains: [:letter |  letter isDigit not]) not])
				ifTrue: [numbers asNumber < 12345
						ifTrue: ['http://system/old/case/' , numbers , '.asp']
						ifFalse: ['http://system/new/case/' , numbers , '.st']]]! !

!PRCustomLinkTest methodsFor: 'running' stamp: 'JCB 2/24/2009 14:03'!
tearDown
	self actualClass conversions: originalConversions.
	super tearDown! !

!PRCustomLinkTest methodsFor: 'testing-parsing' stamp: 'JCB 2/24/2009 14:50'!
testParseCase
	"self debug: #testParseCase"
	| wiki text tree link |
	wiki := '*case 12345*'.
	text := 'case 12345'.
	self
		assert: (self actualClass isValidReference: text);		
		deny: (self actualClass isValidReference: 'case 1234a').
	link := self actualClass new reference: text;
				 yourself.
	tree := PRDocument new add: (PRParagraph new add: link;
					 yourself);
				 yourself.
	self assertWiki: wiki equalsTree: tree.
	self assertTree: tree equalsWiki: wiki.
	self assertTree: tree equalsText: text.
	self
		assert: ('*/new/*' match: link url).
	link := self actualClass new reference: 'case 12344';
				 yourself.
	self
		assert: ('*/old/*' match: link url)! !

PRNavigationWidget subclass: #PRPathNavigationWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-SW2-Sw1Features'!

!PRPathNavigationWidget class methodsFor: 'accessing' stamp: 'JCB 3/1/2009 21:10'!
label
	^ 'Link Path'! !

!PRPathNavigationWidget methodsFor: 'rendering' stamp: 'JCB 3/1/2009 21:07'!
renderParents: aCollection on: html
	| active path |
	active := self isActive: aCollection first.
	path := active and: [ self selected parents includes: aCollection first ].
	html anchor
		class: 'path' if: path;
		class: 'active' if: active;
		goto: (self context structure: aCollection first);
		with: '/'.
	aCollection allButFirst do: [:e | self renderItem: e on: html] separatedBy: [html text: '/']! !
